/*
 BPE 
 
cl bpe.c crc32t.c /O2 /GLA /arch:SSE2 /link /opt:ref,icf,nowin98
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "bpe.h"

#define MAXPASS 255
#define BPEHEAD "BPE2"


//ŏo2oCgԂ
static ulong getmaxpair(ulong *ppair)
{
	ulong max = 3, t = BPE_ERROR, n;
	
	for(n=0; n<65536;n++) {
		if (ppair[n] > max) {
			max = ppair[n];
			t = n;
		}
	}

	return t;
}

//󂫕Ԃ
static ulong getkaramoji(ulong *pkaramoji)
{
	ulong n;
	
	for(n=0; n<256;n++) {
		if (pkaramoji[n] == 0) {
			return n;
		}
	}
	return BPE_ERROR;
}



//opxƋ󂫕T
static int search(uchar *data, ulong len, BPE_DIC *pdic)
{
	ulong n;
	ulong pair[65536]={0}, moji[256]={0};
	ulong twobyte, onebyte;
	ulong max = 3, t = BPE_ERROR;
	
	for (n=0; n<len; n++) {
		moji[data[n]]++;
		if (n==len-1) break;
		
		twobyte = (((data[n] << 8) & 0xFF00) | (data[n+1] & 0x00FF));
		pair[twobyte]++;
	}
	
	twobyte = getmaxpair(pair);
	onebyte = getkaramoji(moji);
	if (twobyte == BPE_ERROR || onebyte == BPE_ERROR) return 0;
	
	
	pdic->twobyte = twobyte;
	pdic->onebyte = onebyte;
	return 1;
}


//divcnt̕ŃGR[hTCYԂ
static ulong test_encode_getsize(uchar *data, ulong len, ulong divcnt)
{
	BPE_DIC bpe_io[MAXPASS];
	uchar *tmp;
	uchar cnt;
	ulong i,j;
	tmp = malloc(len/divcnt);
	for (i=j=0; i<divcnt;i++) {
		memcpy(tmp, data+(len/divcnt)*i, len/divcnt);
		cnt=0;
		j += frame_encode(tmp, len/divcnt, bpe_io, &cnt, len);
		j += (cnt*3)+5;
	}
	free(tmp);
	return j;
}


//data1~4ăGR[hAłȂ镪Ԃ
static ulong test_encode(uchar *data, ulong len)
{
	ulong div1, div2, div3, div4;
	
	
	div1 = test_encode_getsize(data, len, 1);
	if (len % 2) {
		div2 = len*2;//؂Ȃ
	} else {
		div2 = test_encode_getsize(data, len, 2);
	}
	
	if (len % 3) {
		div3 = len*2;//؂Ȃ
	} else {
		div3 = test_encode_getsize(data, len, 3);
	}
	
	if (len % 4) {
		div4 = len*2;//؂Ȃ
	} else {
		div4 = test_encode_getsize(data, len, 4);
	}
	
	
	if (div1 <= div2 && div1 <= div3 && div1 <= div4) return 1;
	if (div2 <= div3 && div2 <= div4) return 2;
	if (div3 <= div4) return 3;

	return 4;
}

//1t[GR[h
ulong frame_encode(uchar *data, ulong len, BPE_DIC *pdic, uchar *pass, ulong framesize)
{
	uchar *tmp;
	ulong n, m;
	
	if (data == NULL || len == 0 || pdic == NULL || pass == NULL || framesize == 0) return len;

	
	tmp = malloc(len);
	*pass = 0;
	do {
		if (search(data, len, &pdic[*pass]) == 0) break;

		for (n=m=0; n<len; n++) {
			if ((((data[n] << 8) & 0xFF00) | (data[n+1] & 0x00FF)) == pdic[*pass].twobyte && n < len-1) {
				tmp[m] = pdic[*pass].onebyte;
				m++;
				n++;
			} else {
				tmp[m] = data[n];
				m++;
			}
		}
		memcpy(data, tmp, m);
		len=m;

		(*pass)++;
	} while (*pass < MAXPASS);
	free(tmp);
	
	return len;

}

//1t[fR[h
ulong frame_decode(uchar *data, ulong len, BPE_DIC *pdic, uchar pass, ulong framesize)
{
	ulong i, n,m;
	uchar h, l;
	uchar *tmp;
	 
	if (data == NULL || len == 0 || pdic == NULL || pass == 0 || framesize == 0) return len;
	tmp = malloc(framesize);
	i=pass;
	while (i--){
		h = (uchar)((pdic[i].twobyte >> 8) & 0x00FF);
		l = (uchar)((pdic[i].twobyte)      & 0x00FF);
		for(m=n=0; n<len; n++) {
			if (data[n] == pdic[i].onebyte) {
				tmp[m]   = h;
				tmp[m+1] = l;
				m+=2;
			} else {
				tmp[m] = data[n];
				m++;
			}
		}
		memcpy(data, tmp, m);
		len = m;
	} 
	free(tmp);
	return len;
}

//GR[h 
ulong bpe_enc(uchar *infile, uchar *outfile, ulong framesize)
{
	BPE_DIC bpe_io[MAXPASS];
	FILE *ifp, *ofp;
	ulong before = 0, after = 0;
	char *data;
	ulong crc32 = 0;
	ushort len, len2;
	uchar cnt;
	ulong divcnt, i;
	ulong fsiz;//
	printf("in:%s\nout:%s\n", infile, outfile);
	
	ifp = fopen(infile, "rb");
	if (ifp == NULL) {
		puts("̓t@CI[vG[");
		return -1;
	}
	
	ofp = fopen(outfile, "wb");
	if (ofp == NULL) {
		puts("o̓t@CI[vG[");
		return -1;
	}
	
	fseek(ifp, 0, SEEK_END);
	fsiz = ftell(ifp);
	rewind(ifp);
	
	fwrite(BPEHEAD,  1, 4, ofp);
	fwrite(&crc32,  1, 4, ofp);//CRC32(0)
	fwrite(&framesize,  2, 1, ofp);
	
	if (framesize == 0) framesize = 2048;
	
	data = malloc(framesize);
	crc32_starts(&crc32);
	
	while ((len = fread(data, 1, framesize, ifp))) {
		crc32_update(&crc32, data, len);
		divcnt = test_encode(data, len);//œK߂
		len /= divcnt;

		for (i=0; i<divcnt;i++) {
			cnt = 0;
			len2 = frame_encode(data+(i*len), len ,bpe_io, &cnt, framesize);
			fwrite(&cnt,  1, 1, ofp);
			fwrite(&len,  2, 1, ofp);
			fwrite(&len2, 2, 1, ofp);
			fwrite(bpe_io, sizeof(BPE_DIC), cnt, ofp);

			fwrite(data+(i*len), 1, len2, ofp);
		}
		before = ftell(ifp);
		after  = ftell(ofp);
		printf("[%5.1f%%]%8dKB->%8dKB\r", (double)before/fsiz*100.0, before/1024, after/1024);
	}
	
	crc32_finish(&crc32);
	fseek(ofp, 4, SEEK_SET);
	fwrite(&crc32,  4, 1, ofp);
	
	
	printf("k : %d->%d(%6.2f%%) \n", before, after, ((double)after/before)*100.0);
	free(data);
	fclose(ofp);
	fclose(ifp);

	return 0;
}

//fR[h
ulong bpe_dec(uchar *infile, uchar *outfile)
{
	
	BPE_DIC bpe_io[MAXPASS];
	FILE *ifp, *ofp;
	uchar *data, head[4];
	ushort decompsize, compsize, ret;
	uchar pass;
	ulong framesize = DEFAULTFRAMESIZE;
	ulong crc32 = 0, crc32_orig = 0;
	ulong compsize_sum = 0, decompsize_sum = 0;
	ulong before = 0, after = 0, fsiz;
	
	printf("in:%s\nout:%s\n", infile, outfile);

	ifp = fopen(infile, "rb");
	if (ifp == NULL) {
		puts("̓t@CI[vG[");
		return -1;
	}
	
	fseek(ifp, 0, SEEK_END);
	fsiz = ftell(ifp);
	rewind(ifp);
	
	if (fread(head,  1, 4, ifp) != 4) {
		puts("wb_ǂݍ߂Ȃ");
		return -1;
	}
	if (memcmp(head, BPEHEAD, strlen(BPEHEAD))) {
		puts("wb_Ȃ");
		return -1;
	}
	
	if (fread(&crc32_orig,  4, 1, ifp) != 1) {
		puts("CRClǂݍ߂Ȃ");
		return -1;
	}
	if (fread(&framesize,  2, 1, ifp) != 1) {
		puts("t[TCYǂݍ߂Ȃ");
		return -1;
	}
	
	ofp = fopen(outfile, "wb");
	if (ofp == NULL) {
		puts("o̓t@CI[vG[");
		return -1;
	}

	
	data = malloc(framesize);
	crc32_starts(&crc32);
	while (1) {
		//wb_ǂݍ
		if (fread(&pass,  1, 1, ifp) == 0) {
		//	puts("JE^ǂݍ߂Ȃ");
			break;
		}
		if (fread(&decompsize,  2, 1, ifp) == 0) {
			puts("\nLTCYǂݍ߂Ȃ");
			break;
		}
		if (fread(&compsize, 2, 1, ifp) == 0) {
			puts("\nkTCYǂݍ߂Ȃ");
			break;
		}
		if (pass && fread(bpe_io, sizeof(BPE_DIC), pass, ifp) == 0) {
			puts("\nǂݍ߂Ȃ");
			break;
		}
		
		//f[^
		ret = fread(data, 1, compsize, ifp);
			if (compsize != ret) {
			printf("\nǂݎTCYG[(%d > %d)\n", compsize, ret);
			break;
		}
		ret = frame_decode(data, compsize, bpe_io, pass, framesize);
			if (decompsize != ret) {
			printf("\nWJG[(orig=%d %d)\n", decompsize, ret);
			break;
		}
		crc32_update(&crc32, data, ret);
		decompsize_sum += decompsize;
		compsize_sum += compsize;
		printf("[%5.1f%%]%8dKB->%8dKB\r", (double)ftell(ifp)/fsiz*100.0, compsize_sum, decompsize_sum);

		fwrite(data, 1, decompsize, ofp);
	}
	
	crc32_finish(&crc32);
	
	before = ftell(ifp);
	after = ftell(ofp);
	
	printf("L : %d->%d(%6.2f%%) crc=%x(%s)\n",
		before, after, ((double)after/before)*100.0,
		crc32, crc32 == crc32_orig ? "TRUE" : "FALSE"
		);

	fclose(ofp);
	free(data);

	return 0;
}

void usage(void) {
	puts("bpe BPEGR[_");
	puts("GR[h [-e] infile [outfile] [-bt[TCY]");
	puts("fR[h -d infile [outfile]");
	return ;
}


int main(int argc, char **argv)
{
	ulong mode, framesize, n;
	uchar in[300], out[300];
	if (argc == 1) {
		usage();
		return 0;
	}
	
	//
	in[0] = out[0] = 0;
	mode = ENCODE;
	framesize = DEFAULTFRAMESIZE;
	
	for (n=1; n<argc; n++) {
		if (argv[n][0] == '-' || argv[n][0] == '/') {
			if (argv[n][1] == 'e') mode = ENCODE;
			if (argv[n][1] == 'd') mode = DECODE;
			
			if (argv[n][1] == 'b') framesize = atoi(&argv[n][2]);
		} else {
			
			//t@C
			if (in[0] != 0 && out[0] == 0) strcpy(out, argv[n]);
			if (in[0] == 0) strcpy(in, argv[n]);
		}
	}
	
	
	if (in[0] == 0) {
		usage();
		return -1;
	}
	
	if (out[0] == 0) {
		if (mode == ENCODE) sprintf(out, "%s.bpe", in);
		if (mode == DECODE) {
			uchar drv[4], dir[300], fnam[300];
			_splitpath(in, drv, dir, fnam, 0);
			sprintf(out, "%s%s%s", drv, dir, fnam);
		}
	}
	
	if (framesize <= 0 || framesize > 65535) framesize = DEFAULTFRAMESIZE;
	framesize = (int)(framesize/12) * 12;//ACg
	
	if (mode == ENCODE) {
		bpe_enc(in, out, framesize);
	} else {
		bpe_dec(in, out);
	}
	
	return 0;
}
